package body Listas_Secuenciales is
	procedure Insertar(L: in out Lista; E: TElemento) is
	begin
		-- Se aade el nuevo elemento como primero de la sublista Posteriores
		Asignar(L.Posteriores,Crear(E,L.Posteriores));
		L.Tamao := L.Tamao + 1;
	exception
		when E_No_espacio => raise E_Lista_Llena;
	end Insertar;

	procedure Extraer(L: in out Lista) is
	begin
		if not Es_Fin(L) then
		-- Se elimina el primer elemento de la sublista Posteriores
			Asignar(L.Posteriores,Resto(L.Posteriores));
			L.Tamao := L.Tamao - 1;
		else
			raise E_Fin_Lista;
		end if;
	end Extraer;

	procedure Avanzar(L: in out Lista) is
	begin
		if not Es_Fin(L) then
		-- Se "pasa" el elemento actual (primero de la sublista Poteriores) a
		-- la sublista Anteriores, insertndose como primero de dicha lista.
			Asignar(L.Anteriores,Crear(Primero(L.Posteriores),L.Anteriores));
		-- Se elimina dicho elemento de la sublista Poteriores.
			Asignar(L.Posteriores,Resto(L.Posteriores));
		else
			raise E_Fin_Lista;
		end if;
	end Avanzar;
			

	procedure Retroceder(L: in out Lista) is
	begin
		if not Es_Inicio(L) then
		-- Se "pasa" el primer elemento de la sublista Anteriores a la
		-- sublista Posteriores, insertndose como primero de dicha lista 
		-- (nuevo elemento actual).
			Asignar(L.Posteriores,
					Crear(Primero(L.Anteriores),L.Posteriores));
		-- Se elimina dicho elemento de la sublista Anteriores.
			Asignar(L.Anteriores,Resto(L.Anteriores));
		else
			raise E_Inicio_Lista;
		end if;
	end Retroceder;
		
	procedure Inicio(L: in out Lista) is
	begin
		-- Se "pasan" todos los elementos de la sublista Anteriores a la
		-- sublista Posteriores, quedando dicha lista vaca.
		while not Es_Inicio(L) loop
			Retroceder(L);
		end loop;
	end Inicio;

	procedure Fin(L: in out Lista) is
	begin
		-- Se "pasan" todos los elementos de la sublista Posteriores a la
		-- sublista Anteriores, quedando dicha lista vaca.
		while not Es_Fin(L) loop
			Avanzar(L);
		end loop;
	end Fin;

	function Es_Inicio(L: in Lista) return Boolean is
	begin
		-- La sublista Anteriores vaca significa que actual seala
		-- al principio de la lista.
		return Es_Vaca(L.Anteriores);
	end Es_Inicio;

	function Es_Fin(L: in Lista) return Boolean is
	begin
		-- La sublista Posteriores vaca significa que actual seala
		-- al final de la lista.
		return Es_Vaca(L.Posteriores);
	end Es_Fin;

	function Examinar(L: in Lista) return TElemento is
	begin
		-- Si actual no est al final de la lista devuelve el
		-- primer elemento de la sublista Posteriores.
		if not Es_Fin(L) then
			return Primero(L.Posteriores);
		else
			raise E_Fin_Lista;
		end if;
	end Examinar;

	function Es_Vaca(L: in Lista) return Boolean is
	begin
		return L.Tamao = 0;
	end Es_Vaca;

	function Tamao(L: in Lista) return Natural is
	begin
		return L.Tamao;
	end Tamao;
end Listas_Secuenciales;
