with Listas_Recursivas;

generic
	type TElemento is private;
package Pilas is
	type Pila is limited private;
	-- Cuando se crea una variable de tipo Pila, est vaca

	procedure Apilar(P: in out Pila; E: in TElemento);
	-- Aade un elemento en la cima de P
	-- Si no puede lanza E_Pila_Llena

	procedure Desapilar(P: in out Pila);
	-- Quita el elemento que ocupa la cima de P
	-- Si P est vaca lanza E_Pila_Vaca

	function Examinar(P: in Pila) return TElemento;
	-- Devuelve el elemento que ocupa la cima de P
	-- Si P est vaca lanza E_Pila_Vaca

	function Es_Vaca(P: in Pila) return Boolean;
	-- Evala si P est vaca

	function Tamao(P: in Pila) return Natural;
	-- Devuelve el nmero de elementos almacenados en P

	-- Se lanza cuando, en una pila vaca, se intenta realizar
	-- una operacin no aplicable a las pilas vacas.
	E_Pila_Vaca: exception;

	-- Se lanza cuando no se puede apilar un elemento por falta de espacio.
	E_Pila_Llena : exception;

private
	package Lista_Elementos is new Listas_Recursivas(TElemento);
	use Lista_Elementos;

	type Pila is record
		Elementos: Lista;
		Tamao   : natural := 0;
	end record;
end Pilas;
