package listasRecursivas;
import copiable.*;

/**
 * Implementacin recursiva de una lista
 */
public class ListaRecursiva implements Cloneable2 {
	/*
	 * Los objetos de la clase Nodo son unidades de una lista encadenada.
	 */
	private class Nodo {
		Cloneable2 info;
		ListaRecursiva siguiente;

		/*
		 * Inicializa un nodo con un elemento y una lista recursiva.
		 */
		Nodo(Cloneable2 e, ListaRecursiva l) {
			try {
				info = (Cloneable2) e.clone();
			} catch (CloneNotSupportedException ex) {
				info = e;
			}
			siguiente = l;
		}
	}

	Nodo lista = null;

	/**
	 * Inicializa una lista vaca.
	 */
	public ListaRecursiva() {
	}

	/**
	 * Inicializa una lista con e como primer elemento y l como resto.
	 * @param e
	 * @param l
	 */
	public ListaRecursiva(Cloneable2 e, ListaRecursiva l) {
		lista = new Nodo(e, l);
	}

	/**
	 * @return el primer elemento de la lista.
	 * (si la lista est vaca, se produce una NullPointerException)
	 */
	public Cloneable2 primero() {
		return lista.info;
	}

	/**
	 * @return la sublista formada por todos los elementos menos el primero.
	 * (si la lista est vaca, se produce una NullPointerException)
	 */
	public ListaRecursiva resto() {
		return lista.siguiente;
	}

	/**
	 * @return true si la lista est vaca y false si no.
	 */
	public boolean esVaca() {
		return lista == null;
	}
	
	/**
	 * @return el nmero de elementos de la lista
	 */
	public int tamao() {
		if (!esVaca()) return 1 + resto().tamao();
		else return 0;	
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	public Object clone() throws CloneNotSupportedException {
		super.clone();
		if (!esVaca())
			return new ListaRecursiva(primero(), (ListaRecursiva) resto().clone());
		else
			return new ListaRecursiva();
	}

}
